/[gentoo-x86]/eclass/qt4.eclass
Gentoo

Diff of /eclass/qt4.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.22 Revision 1.62
1# Copyright 2005 Gentoo Foundation 1# Copyright 2005-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/qt4.eclass,v 1.22 2007/08/02 11:22:40 caleb Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/qt4.eclass,v 1.62 2010/08/14 22:55:27 wired Exp $
4
5# @DEPRECATED
6# This eclass has been superseded by qt4-r2
7# Please modify your ebuilds to use that instead
8
9# @ECLASS: qt4.eclass
10# @MAINTAINER:
11# Ben de Groot <yngwin@gentoo.org>,
12# Markos Chandras <hwoarang@gentoo.org>,
13# Caleb Tennis <caleb@gentoo.org>,
14# Przemyslaw Maciag <troll@gentoo.org>,
15# Davide Pesavento <davidepesa@gmail.com>
16# @BLURB: Eclass for Qt4 packages
17# @DESCRIPTION:
18# This eclass contains various functions that may be useful
19# when dealing with packages using Qt4 libraries.
20
21inherit base eutils multilib toolchain-funcs versionator
22
23export XDG_CONFIG_HOME="${T}"
24
25qt4_monolithic_to_split_flag() {
26 case ${1} in
27 zlib)
28 # Qt 4.4+ is always built with zlib enabled, so this flag isn't needed
29 ;;
30 gif|jpeg|png)
31 # qt-gui always installs with these enabled
32 checkpkgs+=" x11-libs/qt-gui"
33 ;;
34 dbus|opengl)
35 # Make sure the qt-${1} package has been installed already
36 checkpkgs+=" x11-libs/qt-${1}"
37 ;;
38 qt3support)
39 checkpkgs+=" x11-libs/qt-${1}"
40 checkflags+=" x11-libs/qt-core:${1} x11-libs/qt-gui:${1} x11-libs/qt-sql:${1}"
41 ;;
42 ssl)
43 # qt-core controls this flag
44 checkflags+=" x11-libs/qt-core:${1}"
45 ;;
46 cups|mng|nas|nis|tiff|xinerama|input_devices_wacom)
47 # qt-gui controls these flags
48 checkflags+=" x11-libs/qt-gui:${1}"
49 ;;
50 firebird|mysql|odbc|postgres|sqlite3)
51 # qt-sql controls these flags. sqlite2 is no longer supported so it uses sqlite instead of sqlite3.
52 checkflags+=" x11-libs/qt-sql:${1%3}"
53 ;;
54 accessibility)
55 eerror "(QA message): Use guiaccessibility and/or qt3accessibility to specify which of qt-gui and qt-qt3support are relevant for this package."
56 # deal with this gracefully by checking the flag for what is available
57 for y in gui qt3support; do
58 has_version x11-libs/qt-${y} && checkflags+=" x11-libs/qt-${y}:${1}"
59 done
60 ;;
61 guiaccessibility)
62 checkflags+=" x11-libs/qt-gui:accessibility"
63 ;;
64 qt3accessibility)
65 checkflags+=" x11-libs/qt-qt3support:accessibility"
66 ;;
67 debug|doc|examples|glib|pch|sqlite|*)
68 # packages probably shouldn't be checking these flags so we don't handle them currently
69 eerror "qt4.eclass currently doesn't handle the use flag ${1} in QT4_BUILT_WITH_USE_CHECK for qt-4.4. This is either an"
70 eerror "eclass bug or an ebuild bug. Please report it at http://bugs.gentoo.org/"
71 ((fatalerrors+=1))
72 ;;
73 esac
74}
75
76# @FUNCTION: qt4_pkg_setup
77# @DESCRIPTION:
78# Default pkg_setup function for packages that depends on qt4. If you have to
79# create ebuilds own pkg_setup in your ebuild, call qt4_pkg_setup in it.
80# This function uses two global vars from ebuild:
81# - QT4_BUILT_WITH_USE_CHECK - contains use flags that need to be turned on for
82# =x11-libs/qt-4*
83# - QT4_OPTIONAL_BUILT_WITH_USE_CHECK - qt4 flags that provides some
84# functionality, but can alternatively be disabled in ${CATEGORY}/${PN}
85# (so qt4 don't have to be recompiled)
4# 86#
5# Author Caleb Tennis <caleb@gentoo.org> 87# NOTE: Using the above vars is now deprecated in favor of eapi-2 use deps
6# 88#
7# This eclass is simple. Inherit it, and in your depend, do something like this: 89# flags to watch for for Qt4.4:
90# zlib png | opengl dbus qt3support | sqlite3 ssl
91qt4_pkg_setup() {
92 local x y checkpkgs checkflags fatalerrors=0 requiredflags=""
93
94 # lots of has_version calls can be very expensive
95 if [[ -n ${QT4_BUILT_WITH_USE_CHECK}${QT4_OPTIONAL_BUILT_WITH_USE_CHECK} ]]; then
96 ewarn "QA notice: The QT4_BUILT_WITH_USE functionality is deprecated and"
97 ewarn "will be removed from future versions of qt4.eclass. Please update"
98 ewarn "the ebuild to use eapi-2 use dependencies instead."
99 has_version x11-libs/qt-core && local QT44=true
100 fi
101
102 for x in ${QT4_BUILT_WITH_USE_CHECK}; do
103 if [[ -n ${QT44} ]]; then
104 # The use flags are different in 4.4 and above, and it's split packages, so this is used to catch
105 # the various use flag combos specified in the ebuilds to make sure we don't error out for no reason.
106 qt4_monolithic_to_split_flag ${x}
107 else
108 [[ ${x} == *accessibility ]] && x=${x#gui} && x=${x#qt3}
109 if ! built_with_use =x11-libs/qt-4* ${x}; then
110 requiredflags="${requiredflags} ${x}"
111 fi
112 fi
113 done
114
115 local optionalflags=""
116 for x in ${QT4_OPTIONAL_BUILT_WITH_USE_CHECK}; do
117 if use ${x}; then
118 if [[ -n ${QT44} ]]; then
119 # The use flags are different in 4.4 and above, and it's split packages, so this is used to catch
120 # the various use flag combos specified in the ebuilds to make sure we don't error out for no reason.
121 qt4_monolithic_to_split_flag ${x}
122 elif ! built_with_use =x11-libs/qt-4* ${x}; then
123 optionalflags="${optionalflags} ${x}"
124 fi
125 fi
126 done
127
128 # The use flags are different in 4.4 and above, and it's split packages, so this is used to catch
129 # the various use flag combos specified in the ebuilds to make sure we don't error out for no reason.
130 for y in ${checkpkgs}; do
131 if ! has_version ${y}; then
132 eerror "You must first install the ${y} package. It should be added to the dependencies for this package (${CATEGORY}/${PN}). See bug #217161."
133 ((fatalerrors+=1))
134 fi
135 done
136 for y in ${checkflags}; do
137 if ! has_version ${y%:*}; then
138 eerror "You must first install the ${y%:*} package with the ${y##*:} flag enabled."
139 eerror "It should be added to the dependencies for this package (${CATEGORY}/${PN}). See bug #217161."
140 ((fatalerrors+=1))
141 else
142 if ! built_with_use ${y%:*} ${y##*:}; then
143 eerror "You must first install the ${y%:*} package with the ${y##*:} flag enabled."
144 ((fatalerrors+=1))
145 fi
146 fi
147 done
148
149 local diemessage=""
150 if [[ ${fatalerrors} -ne 0 ]]; then
151 diemessage="${fatalerrors} fatal errors were detected. Please read the above error messages and act accordingly."
152 fi
153 if [[ -n ${requiredflags} ]]; then
154 eerror
155 eerror "(1) In order to compile ${CATEGORY}/${PN} first you need to build"
156 eerror "=x11-libs/qt-4* with USE=\"${requiredflags}\" flag(s)"
157 eerror
158 diemessage="(1) recompile qt4 with \"${requiredflags}\" USE flag(s) ; "
159 fi
160 if [[ -n ${optionalflags} ]]; then
161 eerror
162 eerror "(2) You are trying to compile ${CATEGORY}/${PN} package with"
163 eerror "USE=\"${optionalflags}\""
164 eerror "while qt4 is built without this particular flag(s): it will"
165 eerror "not work."
166 eerror
167 eerror "Possible solutions to this problem are:"
168 eerror "a) install package ${CATEGORY}/${PN} without \"${optionalflags}\" USE flag(s)"
169 eerror "b) re-emerge qt4 with \"${optionalflags}\" USE flag(s)"
170 eerror
171 diemessage="${diemessage}(2) recompile qt4 with \"${optionalflags}\" USE flag(s) or disable them for ${PN} package\n"
172 fi
173
174 [[ -n ${diemessage} ]] && die "can't install ${CATEGORY}/${PN}: ${diemessage}"
175}
176
177# @ECLASS-VARIABLE: PATCHES
178# @DESCRIPTION:
179# In case you have patches to apply, specify them in the PATCHES variable.
180# Make sure to specify the full path. This variable is necessary for the
181# src_prepare phase.
182# example:
183# PATCHES=(
184# "${FILESDIR}/mypatch.patch"
185# "${FILESDIR}/mypatch2.patch"
186# )
8# 187#
9# DEPEND="$(qt4_min_version 4)" 188# @FUNCTION: qt4_src_prepare
10# 189# @DESCRIPTION:
11# and it handles the rest for you 190# Default src_prepare function for packages that depend on qt4. If you have to
12# 191# override src_prepare in your ebuild, you should call qt4_src_prepare in it,
13# 08.16.06 - Renamed qt_min_* to qt4_min_* to avoid conflicts with the qt3 eclass. 192# otherwise autopatcher will not work!
14# - Caleb Tennis <caleb@gentoo.org> 193qt4_src_prepare() {
15 194 debug-print-function $FUNCNAME "$@"
16inherit eutils multilib toolchain-funcs versionator 195 base_src_prepare
17
18IUSE="${IUSE}"
19
20QTPKG="x11-libs/qt-"
21QT4MAJORVERSIONS="4.3 4.2 4.1 4.0"
22QT4VERSIONS="4.3.0 4.3.0_rc1 4.3.0_beta1 4.2.3-r1 4.2.3 4.2.2 4.2.1 4.2.0-r2 4.2.0-r1 4.2.0 4.1.4-r2 4.1.4-r1 4.1.4 4.1.3 4.1.2 4.1.1 4.1.0 4.0.1 4.0.0"
23
24qt4_min_version() {
25 echo "|| ("
26 qt4_min_version_list "$@"
27 echo ")"
28} 196}
29 197
30qt4_min_version_list() { 198# @FUNCTION: eqmake4
31 local MINVER="$1" 199# @USAGE: [.pro file] [additional parameters to qmake]
32 local VERSIONS="" 200# @DESCRIPTION:
33 201# Runs qmake on the specified .pro file (defaults to ${PN}.pro if called
34 case "${MINVER}" in 202# without arguments). Additional parameters are appended unmodified to
35 4|4.0|4.0.0) VERSIONS="=${QTPKG}4*";; 203# qmake command line. For recursive build systems, i.e. those based on
36 4.1|4.1.0|4.2|4.2.0) 204# the subdirs template, you should run eqmake4 on the top-level project
37 for x in ${QT4MAJORVERSIONS}; do 205# file only, unless you have strong reasons to do things differently.
38 if $(version_is_at_least "${MINVER}" "${x}"); then 206# During the building, qmake will be automatically re-invoked with the
39 VERSIONS="${VERSIONS} =${QTPKG}${x}*" 207# right arguments on every directory specified inside the top-level
40 fi 208# project file by the SUBDIRS variable.
41 done
42 ;;
43 4*)
44 for x in ${QT4VERSIONS}; do
45 if $(version_is_at_least "${MINVER}" "${x}"); then
46 VERSIONS="${VERSIONS} =${QTPKG}${x}"
47 fi
48 done
49 ;;
50 *) VERSIONS="=${QTPKG}4*";;
51 esac
52
53 echo "${VERSIONS}"
54}
55
56qt4_pkg_setup() {
57 for x in ${QT4_BUILT_WITH_USE_CHECK}; do
58 if ! built_with_use =x11-libs/qt-4* $x; then
59 die "This package requires Qt4 to be built with the '${x}' use flag."
60 fi
61 done
62}
63
64eqmake4() { 209eqmake4() {
65 local LOGFILE="${T}/qmake-$$.out" 210 has "${EAPI:-0}" 0 1 2 && use !prefix && EPREFIX=
66 local projprofile="${1}" 211
67 [ -z ${projprofile} ] && projprofile="${PN}.pro" 212 local projectfile="${1:-${PN}.pro}"
68 shift 1 213 shift
69 214
70 ebegin "Processing qmake ${projprofile}"
71
72 # file exists?
73 if [ ! -f ${projprofile} ]; then 215 if [[ ! -f ${projectfile} ]]; then
74 echo 216 echo
75 eerror "Project .pro file \"${projprofile}\" does not exists" 217 eerror "Project file '${projectfile#${WORKDIR}/}' does not exists!"
76 eerror "qmake cannot handle non-existing .pro files" 218 eerror "eqmake4 cannot handle non-existing project files."
219 eerror
220 eerror "This shouldn't happen - please send a bug report to http://bugs.gentoo.org/"
77 echo 221 echo
78 eerror "This shouldn't happen - please send a bug report to bugs.gentoo.org"
79 echo
80 die "Project file not found in ${PN} sources" 222 die "Project file not found in ${CATEGORY}/${PN} sources."
81 fi 223 fi
82 224
83 echo >> ${LOGFILE} 225 ebegin "Running qmake on ${projectfile}"
84 echo "****** qmake ${projprofile} ******" >> ${LOGFILE}
85 echo >> ${LOGFILE}
86 226
87 # as a workaround for broken qmake, put everything into file 227 # make sure CONFIG variable is correctly set for both release and debug builds
228 local CONFIG_ADD="release"
229 local CONFIG_REMOVE="debug"
88 if has debug ${IUSE} && use debug; then 230 if has debug ${IUSE} && use debug; then
89 echo -e "$CONFIG -= release\nCONFIG += no_fixpath debug" >> ${projprofile} 231 CONFIG_ADD="debug"
90 else 232 CONFIG_REMOVE="release"
91 echo -e "$CONFIG -= debug\nCONFIG += no_fixpath release" >> ${projprofile} 233 fi
234 local awkscript='BEGIN {
235 printf "### eqmake4 was here ###\n" > file;
236 fixed=0;
237 }
238 /^[[:blank:]]*CONFIG[[:blank:]]*[\+\*]?=/ {
239 for (i=1; i <= NF; i++) {
240 if ($i ~ rem || $i ~ /debug_and_release/)
241 { $i=add; fixed=1; }
242 }
243 }
244 /^[[:blank:]]*CONFIG[[:blank:]]*-=/ {
245 for (i=1; i <= NF; i++) {
246 if ($i ~ add) { $i=rem; fixed=1; }
247 }
248 }
249 {
250 print >> file;
251 }
252 END {
253 printf "\nCONFIG -= debug_and_release %s\n", rem >> file;
254 printf "CONFIG += %s\n", add >> file;
255 print fixed;
256 }'
257 local filepath=
258 while read filepath; do
259 local file="${filepath#./}"
260 grep -q '^### eqmake4 was here ###$' "${file}" && continue
261 local retval=$({
262 rm -f "${file}" || echo "FAILED"
263 awk -v file="${file}" -- "${awkscript}" add=${CONFIG_ADD} rem=${CONFIG_REMOVE} || echo "FAILED"
264 } < "${file}")
265 if [[ ${retval} == 1 ]]; then
266 einfo " Fixed CONFIG in ${file}"
267 elif [[ ${retval} != 0 ]]; then
268 eerror " An error occurred while processing ${file}"
269 die "eqmake4 failed to process '${file}'."
92 fi 270 fi
271 done < <(find "$(dirname "${projectfile}")" -type f -name "*.pr[io]" 2>/dev/null)
93 272
94 /usr/bin/qmake ${projprofile} \ 273 "${EPREFIX}"/usr/bin/qmake -makefile -nocache \
95 QTDIR=/usr/$(get_libdir) \ 274 QTDIR="${EPREFIX}"/usr/$(get_libdir) \
96 QMAKE=/usr/bin/qmake \ 275 QMAKE="${EPREFIX}"/usr/bin/qmake \
97 QMAKE_CC=$(tc-getCC) \ 276 QMAKE_CC=$(tc-getCC) \
98 QMAKE_CXX=$(tc-getCXX) \ 277 QMAKE_CXX=$(tc-getCXX) \
99 QMAKE_LINK=$(tc-getCXX) \ 278 QMAKE_LINK=$(tc-getCXX) \
100 QMAKE_CFLAGS_RELEASE="${CFLAGS}" \ 279 QMAKE_CFLAGS_RELEASE="${CFLAGS}" \
101 QMAKE_CFLAGS_DEBUG="${CFLAGS}" \ 280 QMAKE_CFLAGS_DEBUG="${CFLAGS}" \
102 QMAKE_CXXFLAGS_RELEASE="${CXXFLAGS}" \ 281 QMAKE_CXXFLAGS_RELEASE="${CXXFLAGS}" \
103 QMAKE_CXXFLAGS_DEBUG="${CXXFLAGS}" \ 282 QMAKE_CXXFLAGS_DEBUG="${CXXFLAGS}" \
104 QMAKE_LFLAGS_RELEASE="${LDFLAGS}" \ 283 QMAKE_LFLAGS_RELEASE="${LDFLAGS}" \
105 QMAKE_LFLAGS_DEBUG="${LDFLAGS}" \ 284 QMAKE_LFLAGS_DEBUG="${LDFLAGS}" \
106 QMAKE_RPATH= \ 285 QMAKE_STRIP= \
107 ${@} >> ${LOGFILE} 2>&1 286 "${projectfile}" "${@}"
108 287
109 local result=$? 288 eend $?
110 eend ${result}
111 289
112 # was qmake successful? 290 # was qmake successful?
113 if [ ${result} -ne 0 ]; then 291 if [[ $? -ne 0 ]]; then
114 echo 292 echo
115 eerror "Running qmake on \"${projprofile}\" has failed" 293 eerror "Running qmake on '${projectfile#${WORKDIR}/}' has failed!"
294 eerror "This shouldn't happen - please send a bug report to http://bugs.gentoo.org/"
116 echo 295 echo
117 eerror "This shouldn't happen - please send a bug report to bugs.gentoo.org"
118 echo
119 die "qmake failed on ${projprofile}" 296 die "qmake failed on '${projectfile}'."
120 fi 297 fi
121 298
122 return ${result} 299 return 0
123} 300}
124 301
302case ${EAPI:-0} in
303 2|3)
304 EXPORT_FUNCTIONS pkg_setup src_prepare
305 ;;
306 0|1)
125EXPORT_FUNCTIONS pkg_setup 307 EXPORT_FUNCTIONS pkg_setup
308 ;;
309esac

Legend:
Removed from v.1.22  
changed lines
  Added in v.1.62

  ViewVC Help
Powered by ViewVC 1.1.20